import topology as t
import neighborhood as n
import rule as r
import operator as o
import agent as a
import automaton as u
import genome as g
import visual2 as v
import curses as c
from distutils.core import setup
from distutils.extension import Extension
from Pyrex.Distutils import build_ext
import random

size = (90,40)
iterate = 30000

tabula = {'ai':'import topology;import neighborhood;import rule;import operator;import automaton;import agent;import genome;import random',
          'at':'topos = topology.ToroidTopology((90,40),0)',
	  'ap':'change = rule.ReductionRule(ball,(operator.xor,0))',
	  'au':'robot = automaton.SynchronousAutomaton_2D(change)',
          'ic':'class corpus:',
          'ii':'  ',
          'id':'def __init__(self, topos):',
          'it':'  self.topos = topos',
	  'an':'  self.ball = neighborhood.VonNeumannNeighborhood(topos)',
          'aw':'def wander(agent):',
	  'ar':'  direction = random.randint(0,4)',
          'ac':'  agent.changeFacing(direction)',
          'aa':'  agent.advance()',
          'zd':'def beBorn(topos):',
	  'zn':'  ball = neighborhood.VonNeumannNeighborhood(topos)',
	  'zm':'  myself = agent.Agent_2D(genome.Genome([],{},2),ball,ball,7,1,(30,8))',
          'za':'  return myself',
	  'pd':'def __print__():',
	  'pp':'  return myself.tellAddress()'}

poeio = ['a','i','z','d','z','n','z','m','z','a','a','w','a','r','a','c','a','a','p','d','p','p']
samskara = g.Genome(poeio, tabula, 2)
samskara.incorporate('creatures/wanderer.py')

annuvin = t.ToroidTopology(size,0)
caer = n.VonNeumannNeighborhood(annuvin)
sidhe = r.ReductionRule(caer,(o.xor,0))
prydain = u.SynchronousAutomaton_2D(sidhe)
bran = a.Agent_2D(samskara,caer,caer,7,1,(40,15))
gwydion = a.Agent_2D(samskara,caer,caer,7,1,(45,5))
gwion = a.Agent_2D(samskara,caer,caer,7,1,(10,12))

# amatheon = a.Agent_2D(samskara,caer,caer,7,1,(30,8))
species = 'creatures/wanderer'
amatheon = __import__(species)
amatheonwy = amatheon.beBorn(annuvin)


#prydain.addAgent(bran)
#prydain.addAgent(gwydion)
prydain.addAgent(amatheonwy)
#prydain.addAgent(gwion)
prydain.set((10,10),1)

print __name__

def main(stdscr):
    v.updateLoop(prydain, stdscr, size)
    stdscr.refresh()

    t = 0
    print "t = %i\r" % (t)
    
    for i in range(iterate):
        prydain.update()
        t = t+1
        amatheon.wander(amatheonwy)
        #print amatheon
	#a = random.randint(0,4)
        #bran.changeFacing(a)
        #bran.advance()
        #a = random.randint(0,4)
        #gwydion.changeFacing(a)
        #gwydion.advance()
        #a = random.randint(0,4)
        #gwion.changeFacing(a)
        #gwion.advance()
        v.updateLoop(prydain, stdscr, size)
        stdscr.refresh()
        print "t = %i" % (t)
    raw_input("Done")



if __name__ == '__main__': c.wrapper(main)
